#include <algorithm>
#include <iostream>
#include <string>
#include <list>
#include <vector>
#include <sdsl/io.hpp>
#include "../index/csi_lzss.hpp"

using namespace std;

int main() {
	typedef typename csi_lzss::size_type size_type;

	//input string from which to build self - index
	cout << "Enter a string to construct index from: ";
	string str = "";
	getline(cin, str);
	//construct selfindex from string
	csi_lzss index(str);
	cout << "Textlen: " << index.textlen() << endl;
	cout << "Size of index in bytes: " << sdsl::size_in_bytes(index) << endl;
	//let user search for patterns until he don't want no more
	cout << "Pattern to search for (empty pattern quits): ";
	string pattern = "";
	for (getline(cin, pattern); !pattern.empty(); pattern = "", getline(cin, pattern)) {
		//Find pattern in string
		list<size_type> l_occ = index.findPattern(pattern);
		//Sort occurences by their position
		vector<size_type> v_occ(l_occ.begin(), l_occ.end());
		sort(v_occ.begin(), v_occ.end());
		//print line containing original string
		cout << "\t" << str << endl;
		//and print markers indicating where occurences start
		cout << "\t" ;
		size_type pos = 0;
		for (auto &occ_pos : v_occ) {
			while (pos < occ_pos) {
				cout << ' ';
				pos++;
			}
			cout << '^';
			pos++;
		}
		cout << endl << "\t" << v_occ.size() << " Occurences" << endl;
		cout << "Pattern to search for (empty pattern quits): ";
	}
	return 0;
}
